@echo off

SET PDIR=%1
SET MP_CC=%2
SET C_SRCS=%~3
SET CFLAGS=%~4

SET PREP_DIR=pilprep

if not exist %PREP_DIR% MKDIR %PREP_DIR%

setlocal EnableDelayedExpansion
  
if not defined PILPREPTOOL (
   FOR /f "tokens=2*" %%A IN ('REG QUERY HKCU\Software\Plexim\PLECS /v PILFrameworkPath 2^>NUL ^| FINDSTR "REG_SZ"') DO (
      SET PILROOT=%%~B%
   )
   @SET "PILPREPTOOL=!PILROOT!\Tools\1.0\win32\pilpreptool.exe"
) 

echo Using %PILPREPTOOL%

SET PILPREPARGS=
FOR %%i IN (%C_SRCS%) DO (
  IF %%~ni NEQ pil_symbols2 (
    %MP_CC% %CFLAGS% -DPIL_PREP_TOOL -E  %%i > %PREP_DIR%\%%~ni.pilpp
    SET "PILPREPARGS=!PILPREPARGS! %PREP_DIR%\%%~ni.pilpp"
  )
)
"%PILPREPTOOL%" %PILPREPARGS% -k "__cregister __interrupt interrupt __inline far __extension__" -postfix -o pil_symbols
DEL %PILPREPARGS%
